#!/usr/bin/env python

import os

def setup(d):

	"Set the directory 'd' up for configuration."

	for i in [
		"6502", "6502/regular", "6502/wide", "gfx",
		"gfx/GGI", "gfx/SDL", "gfx/Allegro",
		"gui", "misc",
		"misc/GII", "misc/SDL", "misc/Allegro",
		"misc/Posix", "misc/UNIX", "misc/NULL",
		"screen", "screen/regular", "screen/wide", "tape",
		"uef", "ula", "wd1770", "fs", "fs/Posix",
		"plus1", "plus1/print",
		"sound/OSS", "sound/SDL", "sound/Allegro",
		"sound"]:

		os.system("cp Makefile.in.sub %s/%s/Makefile.in" % (d, i))

	os.system("cp Makefile.in %s" % d)
	os.system("cp configure %s" % d)
	os.system("cp INSTALL.txt %s" % d)
	os.system("cp *.kyb %s" % d)
	os.system("cp *.uef %s" % d)
	os.system("cp electrem.cfg.in %s" % d)
	os.system("cp install-sh %s" % d)

	# Patches and new files not included in ElectrEm.

	for i in [
		"PATCH_targets.h",
		"PATCH_gfx_Allegro_platgfx.cpp",
		"PATCH_misc_Allegro_aplatipt.cpp",
		"PATCH_sound_SDL_soundcard.cpp",
		"PATCH_gfx_gfxdraw.cpp",
		"PATCH_misc_input.cpp",
		"PATCH_tape_fasttape.cpp",
		"PATCH_6502_regular_core.cpp",
		"PATCH_6502_wide_wcore.cpp",
		"PATCH_uef_uef.h",
		"PATCH_gfx_gfx.h"
		]:

		os.system("patch -p0 -d %s < patches/%s" % (d, i))

	os.system("cp patches/%s %s/targets" % ("targ_allegro.h", d))

	# SDL keyboard patch.

	apply_sdl_patches = raw_input("Apply SDL patches? yes/[no] ") or "no"

	if apply_sdl_patches in ("yes", "y"):

		# Apply the patches.

		sdl_source_dir = raw_input(
			"Where is the SDL source directory? [../SDL-1.2.2] ") \
			or "../SDL-1.2.2"

		os.system("patch -p0 -d %s < patches/%s" % (sdl_source_dir,
			"PATCH-SDL-1.2.2_src_events_SDL_keyboard.c"))

if __name__ == "__main__":

	# Do not set up the current directory by default!

	import sys, fixnames

	if len(sys.argv) >= 2 and os.path.isdir(sys.argv[1]):
		fixnames.fixnames(sys.argv[1])
		setup(sys.argv[1])
	else:
		print "Specify a directory!"
		sys.exit(1)
